class Button {
  float buttonX, buttonY;
  int buttonWidth, buttonHeight;
  color buttonColor, baseColor, frame;
  color buttonHighlight, currentColor;
  boolean buttonOver;
  
  
  Button(float _x, float _y, int w, int h, color outline) {
    
  buttonX = _x;
  buttonY = _y;
  frame = outline;
  buttonColor = color(0);
  buttonHighlight = color(51);
  baseColor = color(102);
  currentColor = baseColor;
  buttonWidth = w;
  buttonHeight = h;
    
  }
  
  boolean overButton(float x, float y, int buttonWidth, int buttonHeight, int clickState)  {            //check if mouse is over button
    if ((mouseX >= x - buttonWidth/2 && mouseX <= x + buttonWidth/2 && mouseY >= y - buttonHeight/2 && mouseY <= y + buttonHeight/2) || (clickState == 1)) {
      return true;
    } else {
      return false;
    }
  }
  
  void update(int clickState) {
    if ( overButton(buttonX, buttonY, buttonWidth, buttonHeight, clickState) ) {      //check if mouse is over the button to change color
      buttonOver = true;
    } 
    else {
      buttonOver = false;
    }
  }
  
  void display() {
    stroke(frame);
    if (buttonOver) {
      fill(buttonHighlight);            //if mous hovers over button change color
      rect(buttonX, buttonY, buttonWidth, buttonHeight, 20);      //play button
    }
    else {
      fill(buttonColor);
      strokeWeight(8);
      rect(buttonX, buttonY, buttonWidth, buttonHeight, 20);      //play button
    }   
  }
  
};
