int choice1 = 0;
int choice2 = 0;
int choice3 = 0;
int choice4 = 0;
int choice5 = 0;
int choice6 = 0;
int last = 0;
int start = 0;        //some variables to store the values from the serial by parseInt

int one = 7;
int two = 6;
int three = 5;
int four = 4;
int five = 3;
int six = 2;          //outlets of the six buttons

int ledYellow = 8;
int ledBlue = 9;
int ledGreen = 10;      //outlets of the three led bulbs

void setup() {
  Serial.begin(9600);
  Serial.println("0,0,0");
 
  pinMode(ledYellow, OUTPUT);
  pinMode(ledBlue, OUTPUT);
  pinMode(ledGreen, OUTPUT);

  pinMode(one, INPUT);
  pinMode(two, INPUT);
  pinMode(three, INPUT);
  pinMode(four, INPUT);
  pinMode(five, INPUT);
  pinMode(six, INPUT);
}

void loop() {
  while (Serial.available()) {
    choice1 = Serial.parseInt();
    choice2 = Serial.parseInt();
    choice3 = Serial.parseInt();
    choice4 = Serial.parseInt();
    choice5 = Serial.parseInt();
    choice6 = Serial.parseInt();
    last = Serial.parseInt();           //stores whether or not the game is off
    start = Serial.parseInt();          //stores whether or not the game has started

    if (Serial.read() == '\n') {
      int sensor = analogRead(A0);
      delay(1);
      int button1 = digitalRead(one);
      delay(1);
      int button2 = digitalRead(two);
      delay(1);
      int button3 = digitalRead(three);
      delay(1);
      int button4 = digitalRead(four);
      delay(1);
      int button5 = digitalRead(five);
      delay(1);
      int button6 = digitalRead(six);
      delay(1);

     if (start == 1) {        //as soon as the game begins after instructions yellow lights
        if (button1 == HIGH || button2 == HIGH || button3 == HIGH || button4 == HIGH || button5 == HIGH || button6 == HIGH) { //while any button is pressed, light blue and dim rest
          digitalWrite(ledBlue, HIGH);
          digitalWrite(ledYellow, LOW);
        }
        else {              //otherwise only keep yellow lit
          digitalWrite(ledBlue, LOW);
          digitalWrite(ledGreen, LOW);
          digitalWrite(ledYellow, HIGH);
        }
      }
      else {              //if game is not on switch yellow and blue off
        digitalWrite(ledYellow, LOW);
        digitalWrite(ledBlue, LOW);
        if (last == 1) {          //if it was specifically on the end page where a pic of character shows, light up the green bulb signifiying end
          digitalWrite(ledGreen, HIGH);  
        }
        else { digitalWrite(ledGreen, LOW);} 
      }
     
      Serial.print(button1);
      Serial.print(",");
      Serial.print(button2);
      Serial.print(",");
      Serial.print(button3);
      Serial.print(",");
      Serial.print(button4);
      Serial.print(",");
      Serial.print(button5);
      Serial.print(",");
      Serial.print(button6);
      Serial.print(",");
      Serial.println(sensor);               //print everything back to complete the handshake
    }
  }
}
